import { InanoSQLTable, InanoSQLPlugin, InanoSQLInstance } from "../interfaces";
import { nanoSQLMemoryIndex } from "./memoryIndex";
import { SnapDB } from "snap-db";
export declare class SnapDBAdapter extends nanoSQLMemoryIndex {
    snapDBArgs?: {
        dir: string;
        key: "string" | "int" | "float";
        cache?: boolean | undefined;
        autoFlush?: number | boolean | undefined;
        mainThread?: boolean | undefined;
    } | undefined;
    plugin: InanoSQLPlugin;
    nSQL: InanoSQLInstance;
    _id: string;
    _ai: {
        [tableName: string]: number;
    };
    _tableConfigs: {
        [tableName: string]: InanoSQLTable;
    };
    _tables: {
        [tableName: string]: SnapDB<any>;
    };
    _baseFolder: string;
    _path: string;
    constructor(snapDBArgs?: {
        dir: string;
        key: "string" | "int" | "float";
        cache?: boolean | undefined;
        autoFlush?: number | boolean | undefined;
        mainThread?: boolean | undefined;
    } | undefined);
    connect(id: string, complete: () => void, error: (err: any) => void): void;
    createTable(tableName: string, tableData: InanoSQLTable, complete: () => void, error: (err: any) => void): void;
    batch(table: string, actions: {
        type: "put" | "del";
        data: any;
    }[], success: (result: any[]) => void, error: (msg: any) => void): void;
    dropTable(tableName: string, complete: () => void, error: (err: any) => void): void;
    disconnect(complete: () => void, error: (err: any) => void): void;
    write(table: string, pk: any, row: {
        [key: string]: any;
    }, complete: (pk: any) => void, error: (err: any) => void): void;
    read(table: string, pk: any, complete: (row: {
        [key: string]: any;
    } | undefined) => void, error: (err: any) => void): void;
    delete(table: string, pk: any, complete: () => void, error: (err: any) => void): void;
    readMulti(table: string, type: "range" | "offset" | "all", offsetOrLow: any, limitOrHigh: any, reverse: boolean, onRow: (row: {
        [key: string]: any;
    }, i: number) => void, complete: () => void, error: (err: any) => void): void;
    getTableIndex(table: string, complete: (index: any[]) => void, error: (err: any) => void): void;
    getTableIndexLength(table: string, complete: (length: number) => void, error: (err: any) => void): void;
}
export declare const rimraf: (dir_path: string) => void;
