import { InanoSQLInstance } from "./interfaces";
import { InanoSQLQueryAST } from "./query2-ast";
export declare enum InanoSQLActions {
    union = 0,
    graph = 1,
    join = 2,
    order = 3,
    group = 4,
    selectFull = 5,
    selectIndex = 6,
    selectPK = 7,
    range = 8,
    where = 9,
    distinct = 10,
    update = 11,
    upsert = 12,
    delete = 13,
    conform = 14,
    rebuildIndexes = 15,
    clone = 16
}
export interface InanoSQLQueryActions {
    do: InanoSQLActions;
    args: {};
}
/**
 * Builds an optimized list of actions for the query engine to perform.
 *
 * Once the list is built, we can execute the query.
 *
 * @param {InanoSQLInstance} nSQL
 * @param {InanoSQLQueryAST} pQuery
 * @returns {InanoSQLQueryActions[]}
 */
export declare const _prepareQuery: (nSQL: InanoSQLInstance, pQuery: InanoSQLQueryAST) => InanoSQLQueryActions[];
