Object.defineProperty(exports, "__esModule", { value: true });
var query2_ast_1 = require("./query2-ast");
var query2_prepare_1 = require("./query2-prepare");
/**
 * Query Order:
 * 0. Process, Prepare then Execute
 * 1. Where / Index Select (possibly do indexed orderby)
 * 2. Union, Join & Graph
 * 3. Group By, Functions & Distinct
 * 4. Apply AS
 * 5. OrderBy (if not done by index/pk)
 * 6. Having
 * 7. Offset & Limit
 */
exports.executeQuery = function (nSQL, query, progress, complete) {
    try {
        // step 1, process query AST
        var queryAST = query2_ast_1._generateAST(query);
        // step 2, prepare query
        var preparedQuery = query2_prepare_1._prepareQuery(nSQL, queryAST);
        // step 3, execute query
    }
    catch (e) {
        complete(e);
    }
};
//# sourceMappingURL=query2.js.map